<template>
  <div class="col-sm-6 col-md-4">
    <div class="card mb-3">
      <div class="card-header">
        <h6>
          {{stock.name}}
          <small>(Price: {{stock.price}})</small>
        </h6>
      </div>
      <div class="card-body">
        <div class="control-section">
          <input
            type="number"
            :class="{ danger: insufficientFunds }"
            class="form-control"
            v-model="quantity"
            placeholder="Quantity"
          />
          <button
            class="btn btn-success"
            :disabled="insufficientFunds || quantity <=0 || !Number(quantity)"
            @click="buyStock"
          >{{ insufficientFunds ? 'Low Funds' : 'Buy' }}</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: ["stock"],
  data() {
    return {
      quantity: 0
    };
  },
  computed: {
    funds() {
      return this.$store.getters.funds;
    },
    insufficientFunds() {
      return this.quantity * this.stock.price > this.funds;
    }
  },
  methods: {
    buyStock() {
      const order = {
        stockId: this.stock.id,
        stockPrice: this.stock.price,
        quantity: this.quantity
      };
      this.$store.dispatch("buyStocks", order);
      this.quantity = 0;
    }
  }
};
</script>

<style scoped>
.danger {
  border: 1px solid red;
  outline: red;
}

.control-section {
  display: flex;
  align-items: center;
  justify-content: space-between;
}
.control-section input {
  margin-right: 15px;
  max-width: 150px;
}

.btn {
  flex-wrap: nowrap;
}
</style>